package com.prolog.eis.service.outbound.impl;

import com.prolog.eis.dao.outbound.BizOutboundTaskDetailHisMapper;
import com.prolog.eis.model.outbound.BizOutboundTaskDetailHis;
import com.prolog.eis.service.outbound.BizOutboundTaskDetailHisService;
import com.prolog.framework.core.restriction.Criteria;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 出库任务详情表-服务实现类
 * @date 2023-07-06 11:36
 */
@Service
public class BizOutboundTaskDetailHisServiceImpl implements BizOutboundTaskDetailHisService {

    @Autowired
    private BizOutboundTaskDetailHisMapper bizOutboundTaskDetailHisMapper;

    /**
     * 新增数据
     *
     * @param bizOutboundTaskDetailHis 出库任务详情表
     */
    @Override
    public long save(BizOutboundTaskDetailHis bizOutboundTaskDetailHis) {
        return bizOutboundTaskDetailHisMapper.save(bizOutboundTaskDetailHis);
    }

    /**
     * 新增批量数据
     *
     * @param bizOutboundTaskDetailHisList 出库任务详情表
     */
    @Override
    public long saveBatch(List<BizOutboundTaskDetailHis> bizOutboundTaskDetailHisList) {
        return bizOutboundTaskDetailHisMapper.saveBatch(bizOutboundTaskDetailHisList);
    }

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDetailHis> findByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailHisMapper.findByMap(paramMap, BizOutboundTaskDetailHis.class);
    }

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    @Override
    public BizOutboundTaskDetailHis findOneByMap(Map<String, Object> paramMap) {
        List<BizOutboundTaskDetailHis> dataList = findByMap(paramMap);
        if(dataList.isEmpty()) {
            return null;
        }
        return dataList.get(0);
    }

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDetailHis> findByCriteria(Criteria criteria) {
        return bizOutboundTaskDetailHisMapper.findByCriteria(criteria);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public BizOutboundTaskDetailHis findById(int id) {
        return bizOutboundTaskDetailHisMapper.findById(id, BizOutboundTaskDetailHis.class);
    }

    /**
     * 修改数据
     *
     * @param bizOutboundTaskDetailHis 实例对象
     */
    @Override
    public long update(BizOutboundTaskDetailHis bizOutboundTaskDetailHis) {
        return bizOutboundTaskDetailHisMapper.update(bizOutboundTaskDetailHis);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    @Override
    public long deleteById(int id) {
        return bizOutboundTaskDetailHisMapper.deleteById(id, BizOutboundTaskDetailHis.class);
    }

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    @Override
    public long deleteByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailHisMapper.deleteByMap(paramMap, BizOutboundTaskDetailHis.class);
    }

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    @Override
    public long findCountByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailHisMapper.findCountByMap(paramMap, BizOutboundTaskDetailHis.class);
    }
}
